package com.smart.gtstrvl;

import com.example.mountaintravel.base.BaseActivity;
import com.example.mountaintravel.util.ToastUtil;
import com.example.mountaintravel.variable.Variable;
import com.example.mountaintravel.view.LoadingView;

import android.net.ConnectivityManager;
import android.net.NetworkInfo.State;
import android.os.Bundle;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.RelativeLayout.LayoutParams;

public class DeviceIntroduceActivity extends BaseActivity implements OnClickListener {
	private WebView deviceintroduce_web;
	private SharedPreferences sp;
	LinearLayout introduce_layout;
	private String url;
	private RelativeLayout deviceintroduce_relative;
	private LoadingView deviceintroduce_loadingview;
	private static final String TAG = "DeviceIntroduceActivity";
	private boolean flag = true;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_device_introduce);
		initTitleBar("登山设备介绍");
		sp = getSharedPreferences("variable", Context.MODE_PRIVATE);
		url = "http://" + Variable.address + "/terminal/deviceshow";

		deviceintroduce_web = (WebView) findViewById(R.id.deviceintroduce_web);
		introduce_layout=(LinearLayout) findViewById(R.id.introduce_layout);
		addview();
		WebSettings wSet = deviceintroduce_web.getSettings();
		wSet.setJavaScriptEnabled(true);
		deviceintroduce_web.getSettings().setDomStorageEnabled(false);
		deviceintroduce_web.getSettings().setAppCacheEnabled(false);
		deviceintroduce_web.setWebViewClient(new WebViewClient() {

			@Override
			public boolean shouldOverrideUrlLoading(WebView view, String url) {
				Log.d(TAG, url);
				deviceintroduce_loadingview.start();
				
				if (url.contains("deviceshow?type")) {
					startActivity(PayActivity.class);
					return true;
				}
				view.loadUrl(url);
				return true;
			}
			@Override
			public void onReceivedError(WebView view, int errorCode,
					String description, String failingUrl) {
				// TODO Auto-generated method stub
				super.onReceivedError(view, errorCode, description, failingUrl);
				ConnectivityManager cwjManager = (ConnectivityManager) getSystemService(DeviceIntroduceActivity.this.CONNECTIVITY_SERVICE);
				State mobile = cwjManager.getNetworkInfo(
						ConnectivityManager.TYPE_MOBILE).getState();
				State wifi = cwjManager.getNetworkInfo(ConnectivityManager.TYPE_WIFI)
						.getState();
				if (!(mobile == State.CONNECTED || mobile == State.CONNECTING
						|| wifi == State.CONNECTED || wifi == State.CONNECTING)) {
					ToastUtil.show(DeviceIntroduceActivity.this, "网络异常，请检查网络");
				} 
				flag=false;
				view.loadUrl("file:///android_asset/loading.html");

			}
			@Override
			public void onPageFinished(WebView view, String url) {
				// TODO Auto-generated method stub
				flag=false;
				deviceintroduce_loadingview.stop();
				deviceintroduce_web.setVisibility(View.VISIBLE);
				deviceintroduce_relative.setVisibility(View.GONE);
				super.onPageFinished(view, url);
			}
			@Override
			public void onPageStarted(WebView view, String url, Bitmap favicon) {
				// TODO Auto-generated method stub
				flag=true;
				new Thread() {
					@Override
					public void run() {
						// super.run();
						int i = 0;
						while (flag) {
							i++;
							Log.d(TAG, i+"");
							try {
								Thread.sleep(1000);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							if (i > 60) {
								runOnUiThread( new Runnable() {
									public void run() {
										deviceintroduce_web.loadUrl("file:///android_asset/loading.html");
										flag = false;
									}
								});
								
							}

						}
					}

				}.start();
				deviceintroduce_relative.setVisibility(View.VISIBLE);
				deviceintroduce_web.setVisibility(View.GONE);
				super.onPageStarted(view, url, favicon);
				Log.d(TAG, url);
			}

		});
		
		deviceintroduce_web.loadUrl(url);
	}

	@SuppressLint("NewApi")
	public void addview() {
		WindowManager manager = (WindowManager) getSystemService(Context.WINDOW_SERVICE);
		Display display = manager.getDefaultDisplay();
		DisplayMetrics outMetrics = new DisplayMetrics();
		display.getRealMetrics(outMetrics);

		deviceintroduce_relative = (RelativeLayout) findViewById(R.id.deviceintroduce_relative);
		deviceintroduce_loadingview = new LoadingView(getBaseContext(),
				outMetrics.widthPixels);
		RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(
				LayoutParams.MATCH_PARENT, 6);
		// lp.addRule(RelativeLayout.ALIGN_BASELINE);
		deviceintroduce_relative.setOnClickListener(this);
		// lp.addRule(RelativeLayout.CENTER_HORIZONTAL, RelativeLayout.TRUE);
		deviceintroduce_relative.addView(deviceintroduce_loadingview, lp);

	}
	public void onResume() {
		// TODO Auto-generated method stub
		deviceintroduce_loadingview.start();
		super.onResume();
	}

	@Override
	public void onPause() {
		// TODO Auto-generated method stub
		deviceintroduce_loadingview.stop();
		super.onPause();
	}
	@SuppressLint("NewApi")
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		flag=false;
		if (deviceintroduce_web!=null) {
			introduce_layout.removeView(deviceintroduce_web);
			deviceintroduce_web.removeAllViews();
			deviceintroduce_web.onPause();
			deviceintroduce_web.destroy();
		}
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		
	}

}
